## yoshimi 2.3.3.1

=== src/CMakeLists.txt ===
#
#   CMakeLists.txt
#
#   Copyright 2009-2011, Alan Calvert
#   Copyright 2014-2023, Will Godfrey & others
#   Copyright 2024, Kristian Amlie, Will Godfrey
#
#   This file is part of yoshimi, which is free software: you can
#   redistribute it and/or modify it under the terms of the GNU General
#   Public License as published by the Free Software Foundation, either
#   version 2 of the License, or (at your option) any later version.
#
#   yoshimi is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with yoshimi.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required (VERSION 3.5)
cmake_policy (VERSION 3.5)
cmake_policy (SET CMP0004 NEW)
if (POLICY CMP0046)
    cmake_policy (SET CMP0046 NEW)
endif () # opengl version
if (POLICY CMP0072)
    cmake_policy (SET CMP0072 NEW)
endif ()

#set(CMAKE_CXX_COMPILER "clang++")

set (CMAKE_CXX_STANDARD 17) # we seem to need both for
add_definitions(-std=gnu++17) # various versions of cmake

add_definitions(-Wall)

# avoid exporting any (spurious) symbols in EXE and Plugin
# Note: the two LV2 descriptors are already marked visibility=default in LV2 headers
cmake_policy (SET CMP0063 NEW)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

# vvv
#add_definitions(-Wpedantic) # full ISO spec
#add_definitions(-Werror) # warnings as errors
#add_definitions(-Wfatal-errors) # stop on first
add_definitions(-Werror=format-security)
#add_definitions(-fsanitize=address)
add_definitions(-Wextra)
add_definitions(-Wno-vla) # Nothing wrong with variable length arrays
#add_definitions(-Wno-unqualified-std-cast-call) # supresses clang warning 'unqualified call'
# ^^^ comment these out on release pushes


project (Yoshimi)

set (YOSHIMI_VERSION "2.3.3.1")

add_definitions (-DMIN_CONFIG_MAJOR=2)
add_definitions (-DMIN_CONFIG_MINOR=3)

file (WRITE version.txt "${YOSHIMI_VERSION}")

set (CMAKE_INCLUDE_CURRENT_DIR ON)
set (CMAKE_USE_RELATIVE_PATHS OFF)
    # relative paths break some scripts(?)
set (CMAKE_SKIP_RULE_DEPENDENCY OFF)
    # Rebuild objects if rules have changed, even if source hasn't.

message (STATUS "Building Yoshimi version ${YOSHIMI_VERSION} for ${CMAKE_SYSTEM_NAME}")

include (CheckCSourceCompiles)
include(GNUInstallDirs)

mark_as_advanced (EXECUTABLE_OUTPUT_PATH)
mark_as_advanced (LIBRARY_OUTPUT_PATH)
mark_as_advanced (CMAKE_BUILD_TYPE)
mark_as_advanced (CMAKE_INSTALL_PREFIX)

# Check for jack session availability
check_c_source_compiles (
    "#include <jack/session.h>
    int main(int argc, char **argv)
    {
        jack_session_event_type_t x = JackSessionSave;
        return 0;
    }" HasJackSession
)

if (HasJackSession)
    option (JackSessionSupport "Include Jack Session Support" ON)
else()
    set (JackSessionSupport OFF)
endif ()

option (BuildFor0ld_X86 "Build for legacy x86 system" OFF)

option (BuildForAMD_X86_64 "Build for AMD x86_64 system" OFF)
option (BuildForCore2_X86_64 "Build for Intel Core2 x86_64 system" OFF)
option (BuildForRasPi4 "Build for ARM Cortex A9 system" OFF)
option (BuildForThisCPU "Build for presently running system" OFF)
option (BuildForDebug "Debug build without optimisation. Enable gdb debugging support" OFF)
option (BuildForDiagnostic "Add diagnostics and debug info for optimised release build" OFF)

option (BuildWithFLTK "Build with FLTK GUI" ON)

#option to build lv2 plugin
option (LV2Plugin "Build yoshimi lv2 plugin interface" ON)

# developer info
option (ShowNoteOnTimes "Report Note-On Times" OFF)
option (ReportNoteEvents "Report Notes On/Off Count" OFF)


set (BuildOptions_X86
    "-msse -msse2 -mfpmath=sse -ffast-math -fomit-frame-pointer"
    CACHE STRING "basic X86 compiler options"
)

set (BuildOptions_X86_64AMD
    "-march=athlon64 -m64 -Wall -msse -msse2 -mfpmath=sse -ffast-math -fno-finite-math-only -fomit-frame-pointer"
    CACHE STRING "X86_64 compiler options"
)

set (BuildOptions_X86_64Core2
    "-march=core2 -m64 -Wall -msse -msse2 -mfpmath=sse -ffast-math -fno-finite-math-only -fomit-frame-pointer"
    CACHE STRING "X86_64 compiler options"
)

set (BuildOptions_RasPi4
    "-march=native -mfloat-abi=hard -mfpu=vfp -mcpu=cortex-a72 -mtune=cortex-a72 -pipe -mvectorize-with-neon-quad -funsafe-loop-optimizations"
    CACHE STRING "Raspberry Pi V4 compiler options"
)

set (BuildOptions_ThisCPU
    "-march=native -mtune=native -Wall"
    CACHE STRING "Current CPU compiler options"
)

set (BuildOptions_Basic
    "-ffast-math -fomit-frame-pointer"
    CACHE STRING "basic compiler options"
)

set (BuildOptions_Debug
    "-O0 -Wpointer-arith -Wpedantic -Wextra" CACHE STRING "Compile without optimisation and with debug information")
set (BuildOptions_Diagnostic
    "-g3 -ggdb" CACHE STRING "Additional flags for debug information and diagnostics")
set (BuildOptions_Release
    "-O3" CACHE STRING "Compile with optimisation for Release builds")

if (BuildWithFLTK)
    add_definitions (-DGUI_FLTK)
endif ()

find_package (PkgConfig REQUIRED)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

check_c_source_compiles (
    "#include <argp.h>
    #include <stdlib.h>
    int main () {
        int argc=1;
        char *argv[]={\"test\"};
        argp_parse(0,argc,argv,0,0,0);
        return 0;
    }" LIBC_HAS_ARGP
)

if (NOT LIBC_HAS_ARGP)
    message(STATUS "libc does not have argp")
    find_library (ARGP_LIB argp REQUIRED)
endif ()

# libz
find_package(ZLIB REQUIRED)

# fftw3f
pkg_check_modules (FFTW3F REQUIRED fftw3f>=0.22)

# mxml
pkg_check_modules (MXML REQUIRED mxml>=2.5)

# Alsa
if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Linux")
    pkg_check_modules (ALSA REQUIRED alsa>=1.0.17)
    add_definitions(-DHAVE_ALSA)
    FIND_LIBRARY(LIBDL_LINUX NAMES dl)
else()

endif ()

# Jack
pkg_check_modules (JACK REQUIRED jack>=0.115.6)

# fontconfig
pkg_check_modules (FONTCONFIG REQUIRED fontconfig>=0.22)
mark_as_advanced(FONTCONFIG_LIBRARIES)


if (BuildWithFLTK)
# libcairo
    pkg_check_modules (LIBCAIRO REQUIRED cairo)

# fltk
    find_package (FLTK REQUIRED)
    mark_as_advanced (FLTK_DIR)
    mark_as_advanced (FLTK_FLUID_EXECUTABLE)
    mark_as_advanced (FLTK_MATH_LIBRARY)
endif ()


# libncurses / libcursesw
set(CURSES_NEED_NCURSES TRUE)
find_package (Curses REQUIRED)

find_path(Readline_ROOT_DIR
    NAMES include/readline/readline.h
)

find_path(Readline_INCLUDE_DIR
    NAMES readline/readline.h
    HINTS ${Readline_ROOT_DIR}/include
)

find_library(Readline_LIBRARY
    NAMES readline
    HINTS ${Readline_ROOT_DIR}/lib
)

#find_package(PkgConfig REQUIRED)
if (Readline_INCLUDE_DIR AND Readline_LIBRARY AND CURSES_LIBRARY)
    set(READLINE_FOUND TRUE)
else()
    FIND_LIBRARY(Readline_LIBRARY NAMES readline)
    include(FindPackageHandleStandardArgs)
    FIND_PACKAGE_HANDLE_STANDARD_ARGS(Readline DEFAULT_MSG Readline_INCLUDE_DIR Readline_LIBRARY )
    MARK_AS_ADVANCED(Readline_INCLUDE_DIR Readline_LIBRARY)
endif ()

mark_as_advanced(
    Readline_ROOT_DIR
    Readline_INCLUDE_DIR
    Readline_LIBRARY
)

if (READLINE_FOUND)
    message (STATUS "Readline library found" )
else()
    message( FATAL_ERROR "Readline library not found! Please install development components (libreadline-dev)" )
endif ()

# set platform specific compiler flags
if (BuildFor0ld_X86)
    set (OurCxxFlags ${BuildOptions_X86})
elseif (BuildForAMD_X86_64)
    set (OurCxxFlags ${BuildOptions_X86_64AMD})
elseif (BuildForCore2_X86_64)
    set (OurCxxFlags ${BuildOptions_X86_64Core2})
elseif (BuildForNEON)
    set (OurCxxFlags ${BuildOptions_NEON})
elseif (BuildForThisCPU)
    set (OurCxxFlags ${BuildOptions_ThisCPU})
else()
    set (OurCxxFlags ${BuildOptions_Basic})
endif ()
set (CMAKE_CXX_FLAGS "${OurCxxFlags} ${CMAKE_CXX_FLAGS}")

if (BuildForDiagnostic OR BuildForDebug)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${BuildOptions_Diagnostic}")
else()
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -DNDEBUG ")
endif ()

if (BuildForDebug)
    set (CMAKE_BUILD_TYPE "Debug")
    set (CMAKE_CXX_FLAGS_DEBUG ${BuildOptions_Debug})
    message (STATUS "DEBUG Build, flags: ${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_DEBUG}")
else()
    set (CMAKE_BUILD_TYPE "Release")
    set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptions_Release})
    message (STATUS "RELEASE Build, flags: ${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_RELEASE}")
endif ()

configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/../desktop/yoshimi.desktop.in"
    "${CMAKE_CURRENT_BINARY_DIR}/yoshimi.desktop"
    IMMEDIATE @ONLY)

set (DSP_sources
    DSP/AnalogFilter.cpp  DSP/Filter.cpp  DSP/FormantFilter.cpp
    DSP/SVFilter.cpp  DSP/Unison.cpp
)

set (Effects_sources
    Effects/Alienwah.cpp  Effects/Chorus.cpp  Effects/Echo.cpp
    Effects/EffectLFO.cpp  Effects/EffectMgr.cpp  Effects/Effect.cpp
    Effects/Phaser.cpp  Effects/Reverb.cpp  Effects/EQ.cpp
    Effects/Distorsion.cpp  Effects/DynamicFilter.cpp
)

set (Misc_sources
    Misc/Bank.cpp  Misc/BuildScheduler.cpp  Misc/CmdOptions.cpp
    Misc/Config.cpp  Misc/InstanceManager.cpp  Misc/Microtonal.cpp  Misc/Part.cpp
    Misc/SynthEngine.cpp  Misc/WavFile.cpp  Misc/XMLwrapper.cpp
)

set (Interface_Sources
    Interface/InterChange.cpp
    Interface/Data2Text.cpp
    Interface/GuiDataExchange.h
    Interface/GuiDataExchange.cpp
    Interface/InterfaceAnchor.h
    Interface/Text2Data.cpp
    Interface/MidiLearn.cpp
    Interface/Vectors.cpp
    Interface/MidiDecode.cpp
    Interface/RingBuffer.h
    Interface/TextLists.h
    Interface/TextLists.cpp
)

set (CLI_Sources
    CLI/CmdInterface.cpp
    CLI/CmdInterpreter.cpp
)

set (Params_sources
    Params/ADnoteParameters.cpp  Params/EnvelopeParams.cpp
    Params/FilterParams.cpp  Params/LFOParams.cpp
    Params/SUBnoteParameters.cpp  Params/PADnoteParameters.cpp
    Params/Controller.cpp  Params/ParamCheck.cpp
    Params/UnifiedPresets.cpp
    Params/OscilParameters.cpp
)

set (Synth_sources
    Synth/ADnote.cpp  Synth/Envelope.cpp  Synth/LFO.cpp  Synth/OscilGen.cpp
    Synth/SUBnote.cpp  Synth/Resonance.cpp  Synth/PADnote.cpp
)

set (MusicIO_sources
    MusicIO/MusicClient.cpp  MusicIO/MusicIO.cpp  MusicIO/JackEngine.cpp
    MusicIO/AlsaEngine.cpp
)

if (BuildWithFLTK)
    set (FltkUI_names
        "PresetsUI" "EnvelopeUI"
        "LFOUI" "FilterUI" "VirKeyboardUI"
        "ConfigUI" "SUBnoteUI" "ResonanceUI"
        "OscilGenUI" "ADnoteUI" "PADnoteUI"
        "EffUI" "BankUI" "PartUI"
        "MicrotonalUI" "MasterUI" "MasterMiscUI"
        "ParametersUI" "ConsoleUI" "VectorUI"
        "MidiLearnUI"
    )

    set (guitmp generated-gui-sources)
    file (MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/${guitmp}")

# workaround fltk_wrap_ui breakage
    set (FltkUI_sources)
    set (FltkUI_headers)
    foreach(basename ${FltkUI_names})
        set (fluidfile "${CMAKE_CURRENT_SOURCE_DIR}/UI/${basename}.fl")
        set (sourcefile "${basename}.cpp")
        set (headerfile "${basename}.h")
        add_custom_command(
            OUTPUT ${sourcefile}
            WORKING_DIRECTORY ${guitmp}
            COMMAND ${FLTK_FLUID_EXECUTABLE} ARGS -c -o .cpp ${fluidfile}
            COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different ${sourcefile} ..
            COMMAND ${CMAKE_COMMAND} ARGS -E copy_if_different ${headerfile} ..
            DEPENDS ${fluidfile}
        )
        set (FltkUI_sources ${FltkUI_sources} "${sourcefile}")
        set (FltkUI_headers ${FltkUI_headers} "${headerfile}")
    endforeach(basename ${FltkUI_names})

    set (FltkUI_sources
        ${FltkUI_sources}
        UI/DynamicTooltip.cpp
        UI/WidgetPDial.cpp
        UI/WidgetCheckButton.cpp
        UI/WidgetSpinner.cpp
        UI/WidgetMWSlider.cpp
        UI/YoshiWin.cpp
        UI/MiscGui.cpp
        UI/Splash.cpp
    )
    set (YOSHI_INCLUDES ${FLTK_INCLUDE_DIR})
endif ()

add_definitions (
    -D'YOSHIMI_VERSION="${YOSHIMI_VERSION}"'

=== debian/changelog ===
yoshimi (2.3.3.1-1) unstable; urgency=medium

  * New upstream version 2.3.3.1
  * Bump Standards-Version to 4.7.0

 -- Dennis Braun <snd@debian.org>  Sun, 06 Oct 2024 12:18:19 +0200

## yoshimi 2.3.3.2

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -55,7 +55,7 @@
 
 project (Yoshimi)
 
-set (YOSHIMI_VERSION "2.3.3.1")
+set (YOSHIMI_VERSION "2.3.3.2")
 
 add_definitions (-DMIN_CONFIG_MAJOR=2)
 add_definitions (-DMIN_CONFIG_MINOR=3)

=== debian/changelog ===
yoshimi (2.3.3.2-1) unstable; urgency=medium

  * New upstream version 2.3.3.2
  * Update copyright information
    + Update d/copyright
    + exclude another binary file from licensecheck
    + Re-generate d/copyright_hints
  * Apply 'wrap-and-sort -ast'

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 12 Dec 2024 20:48:58 +0100

=== debian/control ===
Source: yoshimi
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Dennis Braun <snd@debian.org>,
 Jaromír Mikeš <mira.mikes@seznam.cz>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dssi-dev,
 fluid,
 libasound2-dev,
 libcairo2-dev,
 libfftw3-dev,
 libfltk1.3-dev,
 libfontconfig-dev,
 libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 libjack-dev | libjack-jackd2-dev,
 libmxml-dev,
 libncurses-dev,
 libreadline-dev,
 libx11-dev,
 libxext-dev,
 lv2-dev,
 pkgconf,
 sharutils,
 zlib1g-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/multimedia-team/yoshimi.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/yoshimi
Homepage: https://yoshimi.github.io

Package: yoshimi
Architecture: any
Depends:
 yoshimi-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 jackd,
 yoshimi-doc,
Description: software synthesizer originally based on ZynAddSubFX2
 Yoshimi is a software synthesizer for GNU/Linux, based on
 ZynAddSubFX 2.4.0.
 .
 Yoshimi maintains sound and instrument compatibility
 but now has extended features and accessibility.

Package: yoshimi-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 yoshimi,
Description: Presets for Yoshimi
 Yoshimi is a software synthesizer originally based on ZynAddSubFX2
 .
 Yoshimi maintains sound and instrument compatibility
 but now has extended features and accessibility.
 .
 This package provides banks and presets for Yoshimi.

Package: yoshimi-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 yoshimi,
Description: Documentation for Yoshimi
 Yoshimi is a software synthesizer originally based on ZynAddSubFX2
 .
 Yoshimi maintains sound and instrument compatibility
 but now has extended features and accessibility.
 .
 This package provides documentation for Yoshimi.

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/yoshimi-$1\.tar\.gz/, \
  dversionmangle=auto" \
https://github.com/Yoshimi/yoshimi/tags .*/v?(\d[\d\.]+)\.tar\.gz

## yoshimi 2.3.3.3

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -18,8 +18,8 @@
 #   You should have received a copy of the GNU General Public License
 #   along with yoshimi.  If not, see <http://www.gnu.org/licenses/>.
 
-cmake_minimum_required (VERSION 3.5)
-cmake_policy (VERSION 3.5)
+cmake_minimum_required (VERSION 3.12)
+cmake_policy (VERSION 3.12)
 cmake_policy (SET CMP0004 NEW)
 if (POLICY CMP0046)
     cmake_policy (SET CMP0046 NEW)
@@ -55,7 +55,7 @@
 
 project (Yoshimi)
 
-set (YOSHIMI_VERSION "2.3.3.2")
+set (YOSHIMI_VERSION "2.3.3.3")
 
 add_definitions (-DMIN_CONFIG_MAJOR=2)
 add_definitions (-DMIN_CONFIG_MINOR=3)

=== debian/changelog ===
yoshimi (2.3.3.3-1) unstable; urgency=medium

  * New upstream version 2.3.3.3
  * Update copyright information
    + Update d/copyright
    + Re-generate d/copyright_hints
  * Apply 'wrap-and-sort -ast'
  * Bump standards version to 4.7.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 02 Mar 2025 23:15:41 +0100

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
  Jaromír Mikeš <mira.mikes@seznam.cz>,
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Build-Depends:
+ debhelper-compat (= 13),
  cmake,
- debhelper-compat (= 13),
  dssi-dev,
  fluid,
  libasound2-dev,
@@ -28,7 +28,7 @@
  pkgconf,
  sharutils,
  zlib1g-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/multimedia-team/yoshimi.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/yoshimi

## yoshimi 2.3.4.1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -55,12 +55,9 @@
 
 project (Yoshimi)
 
-set (YOSHIMI_VERSION "2.3.3.3")
-
-add_definitions (-DMIN_CONFIG_MAJOR=2)
-add_definitions (-DMIN_CONFIG_MINOR=3)
-
+set (YOSHIMI_VERSION "2.3.4.1")
 file (WRITE version.txt "${YOSHIMI_VERSION}")
+
 
 set (CMAKE_INCLUDE_CURRENT_DIR ON)
 set (CMAKE_USE_RELATIVE_PATHS OFF)
@@ -305,7 +302,7 @@
 set (Misc_sources
     Misc/Bank.cpp  Misc/BuildScheduler.cpp  Misc/CmdOptions.cpp
     Misc/Config.cpp  Misc/InstanceManager.cpp  Misc/Microtonal.cpp  Misc/Part.cpp
-    Misc/SynthEngine.cpp  Misc/WavFile.cpp  Misc/XMLwrapper.cpp
+    Misc/SynthEngine.cpp  Misc/WavFile.cpp  Misc/XMLStore.cpp
 )
 
 set (Interface_Sources
@@ -388,7 +385,6 @@
         UI/WidgetCheckButton.cpp
         UI/WidgetSpinner.cpp
         UI/WidgetMWSlider.cpp
-        UI/YoshiWin.cpp
         UI/MiscGui.cpp
         UI/Splash.cpp
     )
@@ -397,3 +393,7 @@
 
 add_definitions (
     -D'YOSHIMI_VERSION="${YOSHIMI_VERSION}"'
+    -D'BASE_INSTALL_DIR="${CMAKE_INSTALL_PREFIX}"'
+    -DYOSHI_FIFO_DIR="${FifoDirectory}"
+)
+

=== src/LV2_Plugin/CMakeLists.txt ===
#
#   CMakeLists.txt (LV2)
#
#   Copyright 2014, Andrew Deryabin <andrewderyabin@gmail.com>
#   Copyright 2018-2023, Will Godfrey & others
#   Copyright 2024 Kristian Amlie
#
#   This file is part of yoshimi, which is free software: you can
#   redistribute it and/or modify it under the terms of the GNU General
#   Public License as published by the Free Software Foundation, either
#   version 2 of the License, or (at your option) any later version.
#
#   yoshimi is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with yoshimi.  If not, see <http://www.gnu.org/licenses/>.

file (GLOB yoshimi_lv2_plugin_files
        YoshimiLV2Plugin.cpp
        YoshimiLV2Plugin.h
        lv2extui.h
        lv2extprg.h)
file (GLOB yoshimi_dsp_files
    ../DSP/AnalogFilter.cpp  ../DSP/Filter.cpp  ../DSP/FormantFilter.cpp
    ../DSP/SVFilter.cpp  ../DSP/Unison.cpp
    ../DSP/FFTwrapper.h  ../DSP/AnalogFilter.h  ../DSP/FormantFilter.h
    ../DSP/SVFilter.h  ../DSP/Filter.h  ../DSP/Unison.h)
file (GLOB yoshimi_effects_files
    ../Effects/Alienwah.cpp  ../Effects/Chorus.cpp  ../Effects/Echo.cpp
    ../Effects/EffectLFO.cpp  ../Effects/EffectMgr.cpp  ../Effects/Effect.cpp
    ../Effects/Phaser.cpp  ../Effects/Reverb.cpp  ../Effects/EQ.cpp
    ../Effects/Distorsion.cpp  ../Effects/DynamicFilter.cpp
    ../Effects/Alienwah.h  ../Effects/Chorus.h  ../Effects/Echo.h
    ../Effects/EffectLFO.h  ../Effects/EffectMgr.h  ../Effects/Effect.h
    ../Effects/Phaser.h  ../Effects/Reverb.h  ../Effects/EQ.h
    ../Effects/Distorsion.h  ../Effects/DynamicFilter.h)
file (GLOB yoshimi_misc_files
    ../Misc/Alloc.h ../Misc/Bank.cpp ../Misc/Bank.h
    ../Misc/BuildScheduler.cpp ../Misc/BuildScheduler.h ../Misc/DataBlockBuff.h
    ../Misc/Config.cpp ../Misc/Config.h ../Misc/ConfBuild.h
    ../Misc/InstanceManager.cpp ../Misc/InstanceManager.h
    ../Misc/Microtonal.cpp ../Misc/Microtonal.h ../Misc/MirrorData.h
    ../Misc/SynthEngine.cpp ../Misc/SynthEngine.h
    ../Misc/Part.cpp ../Misc/Part.h../Misc/TestInvoker.h ../Misc/TestSequence.h
    ../Misc/WavFile.cpp ../Misc/WavFile.h ../Misc/WaveShapeSamples.h
    ../Misc/XMLStore.cpp ../Misc/XMLStore.h)
file (GLOB yoshimi_interface_files
    ../Interface/GuiDataExchange.cpp ../Interface/GuiDataExchange.h
    ../Interface/InterfaceAnchor.h
    ../Interface/MidiDecode.cpp ../Interface/MidiDecode.h
    ../Interface/Vectors.cpp ../Interface/Vectors.h
    ../Interface/InterChange.cpp ../Interface/InterChange.h
    ../Interface/Data2Text.cpp ../Interface/Data2text.h
    ../Interface/Text2Data.cpp ../Interface/Text2Data.h
    ../Interface/TextLists.cpp ../Interface/TextLists.h
    ../Interface/RingBuffer.h
    ../Interface/MidiLearn.cpp ../Interface/MidiLearn.h
    ../UI/MiscGui.cpp ../UI/MiscGui.h)
file (GLOB yoshimi_params_files
    ../Params/ADnoteParameters.cpp  ../Params/EnvelopeParams.cpp
    ../Params/FilterParams.cpp  ../Params/LFOParams.cpp
    ../Params/SUBnoteParameters.cpp  ../Params/PADnoteParameters.cpp
    ../Params/Controller.cpp  ../Params/ParamCheck.cpp  ../Params/UnifiedPresets.cpp
    ../Params/ADnoteParameters.h  ../Params/EnvelopeParams.h
    ../Params/FilterParams.h  ../Params/LFOParams.h
    ../Params/SUBnoteParameters.h
    ../Params/PADnoteParameters.h ../Params/PADStatus.h ../Params/RandomWalk.h
    ../Params/OscilParameters.cpp ../Params/OscilParameters.h
    ../Params/Controller.h  ../Params/ParamCheck.h ../Params/UnifiedPresets.h)
file (GLOB yoshimi_synth_files
    ../Synth/ADnote.cpp  ../Synth/Envelope.cpp  ../Synth/LFO.cpp  ../Synth/OscilGen.cpp
    ../Synth/SUBnote.cpp  ../Synth/Resonance.cpp  ../Synth/PADnote.cpp
    ../Synth/ADnote.h  ../Synth/Envelope.h  ../Synth/LFO.h  ../Synth/OscilGen.h
    ../Synth/SUBnote.h  ../Synth/Resonance.h  ../Synth/PADnote.h
    ../Synth/WaveInterpolator.h ../Synth/XFadeManager.h ../Synth/BodyDisposal.h)
file (GLOB yoshimi_musicio_files
    ../MusicIO/MusicClient.cpp ../MusicIO/MusicClient.h
    ../MusicIO/MusicIO.cpp ../MusicIO/MusicIO.h)
file (GLOB yoshimi_manifest_ttl
    manifest.ttl)
file (GLOB yoshimi_plugin_ttl
    yoshimi.ttl)

set (FltkUI_names
    "PresetsUI"  "EnvelopeUI"
    "LFOUI"  "FilterUI"  "VirKeyboardUI"
    "ConfigUI"  "SUBnoteUI"  "ResonanceUI"
    "OscilGenUI"  "ADnoteUI"  "PADnoteUI"
    "EffUI"  "BankUI"  "PartUI"
    "MicrotonalUI"  "MasterUI" "MasterMiscUI"
    "ParametersUI" "ConsoleUI" "VectorUI"
    "MidiLearnUI"
)

# workaround fltk_wrap_ui breakage
set (FltkUI_sources)
set (FltkUI_headers)
foreach(basename ${FltkUI_names})
    set (fluidfile "${CMAKE_CURRENT_SOURCE_DIR}/../UI/${basename}.fl")
    set (sourcefile "${basename}.cpp")
    set (headerfile "${basename}.h")
    add_custom_command(
      OUTPUT ${sourcefile}
      COMMAND ${FLTK_FLUID_EXECUTABLE} ARGS -c -o .cpp ${fluidfile}
      DEPENDS ${fluidfile}
    )
    set (FltkUI_sources ${FltkUI_sources} "${sourcefile}")
    set (FltkUI_headers ${FltkUI_headers} "${headerfile}")
endforeach(basename ${FltkUI_names})

set (FltkUI_sources
    ${FltkUI_sources}
    ../UI/DynamicTooltip.cpp
    ../UI/WidgetPDial.cpp
    ../UI/WidgetMWSlider.cpp
    ../UI/WidgetCheckButton.cpp
    ../UI/WidgetSpinner.cpp
)

add_definitions (-DYOSHIMI_LV2_PLUGIN=1)

add_library (yoshimi_lv2 MODULE
            ${yoshimi_lv2_plugin_files}
            ${yoshimi_manifest_ttl}
            ${yoshimi_plugin_ttl}
            ${yoshimi_dsp_files}
            ${yoshimi_effects_files}
            ${yoshimi_misc_files}
            ${yoshimi_interface_files}
            ${yoshimi_params_files}
            ${yoshimi_synth_files}
            ${yoshimi_musicio_files}
            ${FltkUI_sources})

add_custom_target(yoshimi_lv2_ttl
                   COMMAND test -f ${yoshimi_manifest_ttl}
                   COMMAND test -f ${yoshimi_plugin_ttl})

SET_TARGET_PROPERTIES(yoshimi_lv2 PROPERTIES PREFIX "")
include_directories (AFTER
                            ${LV2_INCLUDE_DIRS}
                            ${FLTK_INCLUDE_DIR}
                            ${MXML_INCLUDE_DIRS}
                            ${FONTCONFIG_INCLUDE_DIRS}
                            ${FFTW3F_INC_DIR}
                            ${CMAKE_CURRENT_SOURCE_DIR}
                            ${CMAKE_SOURCE_DIR})

target_link_libraries(yoshimi_lv2
                      ${LV2_LIBRARIES}
                      ${FLTK_LIBRARIES}
                      ${MXML_LIBRARIES}
                      ${LIBSNDFILE_LIBRARIES}
                      ${FFTW3F_LIBRARIES}
                      ${LIBCAIRO_LIBRARIES}
                      z
                      ${LIBDL_LINUX_LIBS}
)

add_dependencies(yoshimi_lv2 yoshimi_lv2_ttl)

install (TARGETS yoshimi_lv2 DESTINATION ${LV2_INSTALL_DIR}/yoshimi.lv2)
install (FILES ${yoshimi_manifest_ttl} ${yoshimi_plugin_ttl}
  DESTINATION ${LV2_INSTALL_DIR}/yoshimi.lv2
)

set_directory_properties(PROPERTY ADDITIONAL_MAKE_CLEAN_FILES "${FltkUI_headers}")

=== debian/changelog ===
yoshimi (2.3.4.1-2) unstable; urgency=medium

  * Bump B-D on fltk to 1.4

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 26 Aug 2025 18:54:45 +0200

yoshimi (2.3.4.1-1) unstable; urgency=medium

  * New upstream version 2.3.4.1
  * Add patch to improve appstream metainfo
  * Drop obsolete lintian-overrides
  * Update copyright information
    + Update d/copyright
    + Drop removed files from d/copyright
    + Re-generate d/copyright_hints
  * Update git repository layout to follow DEP-14

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 26 Aug 2025 12:19:32 +0200

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  libasound2-dev,
  libcairo2-dev,
  libfftw3-dev,
- libfltk1.3-dev,
+ libfltk1.4-dev,
  libfontconfig-dev,
  libgl-dev,
  libglu1-mesa-dev | libglu-dev,

## yoshimi 2.3.5

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -55,7 +55,7 @@
 
 project (Yoshimi)
 
-set (YOSHIMI_VERSION "2.3.4.1")
+set (YOSHIMI_VERSION "2.3.5 rc3")
 file (WRITE version.txt "${YOSHIMI_VERSION}")
 
 
@@ -102,6 +102,8 @@
 
 option (BuildWithFLTK "Build with FLTK GUI" ON)
 
+option (BuildWithFLTK4 "Build for FLTK V4+" ON)
+
 #option to build lv2 plugin
 option (LV2Plugin "Build yoshimi lv2 plugin interface" ON)
 
@@ -149,6 +151,10 @@
 
 if (BuildWithFLTK)
     add_definitions (-DGUI_FLTK)
+endif ()
+
+if (BuildWithFLTK4)
+    add_definitions (-DIS_FLTK_4)
 endif ()
 
 find_package (PkgConfig REQUIRED)
@@ -387,13 +393,9 @@
         UI/WidgetMWSlider.cpp
         UI/MiscGui.cpp
         UI/Splash.cpp
+        UI/ScaleTrackedWindow.cpp
     )
     set (YOSHI_INCLUDES ${FLTK_INCLUDE_DIR})
 endif ()
 
 add_definitions (
-    -D'YOSHIMI_VERSION="${YOSHIMI_VERSION}"'
-    -D'BASE_INSTALL_DIR="${CMAKE_INSTALL_PREFIX}"'
-    -DYOSHI_FIFO_DIR="${FifoDirectory}"
-)
-

=== debian/changelog ===
yoshimi (2.3.5-1) unstable; urgency=medium

  [ IOhannes m zmölnig (Debian/GNU) ]
  * New upstream version 2.3.4.2

  [ Dennis Braun ]
  * New upstream version 2.3.5
  * Drop metadata patch applied by upstream

 -- Dennis Braun <snd@debian.org>  Sun, 28 Sep 2025 20:03:38 +0200

## yoshimi 2.3.5.1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -55,7 +55,7 @@
 
 project (Yoshimi)
 
-set (YOSHIMI_VERSION "2.3.5 rc3")
+set (YOSHIMI_VERSION "2.3.5.1")
 file (WRITE version.txt "${YOSHIMI_VERSION}")
 
 
@@ -102,8 +102,6 @@
 
 option (BuildWithFLTK "Build with FLTK GUI" ON)
 
-option (BuildWithFLTK4 "Build for FLTK V4+" ON)
-
 #option to build lv2 plugin
 option (LV2Plugin "Build yoshimi lv2 plugin interface" ON)
 
@@ -151,10 +149,6 @@
 
 if (BuildWithFLTK)
     add_definitions (-DGUI_FLTK)
-endif ()
-
-if (BuildWithFLTK4)
-    add_definitions (-DIS_FLTK_4)
 endif ()
 
 find_package (PkgConfig REQUIRED)
@@ -399,3 +393,5 @@
 endif ()
 
 add_definitions (
+    -D'YOSHIMI_VERSION="${YOSHIMI_VERSION}"'
+    -D'BASE_INSTALL_DIR="${CMAKE_INSTALL_PREFIX}"'

=== debian/changelog ===
yoshimi (2.3.5.1-2) unstable; urgency=medium

  * Drop useless B-D on dssi-dev

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 04 Nov 2025 17:44:45 +0100

yoshimi (2.3.5.1-1) unstable; urgency=medium

  * New upstream version 2.3.5.1

 -- Dennis Braun <snd@debian.org>  Thu, 02 Oct 2025 18:45:50 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,6 @@
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
- dssi-dev,
  fluid,
  libasound2-dev,
  libcairo2-dev,

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export LV2_PATH = /usr/lib/lv2

%:
	dh $@ --sourcedirectory=src

DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*|doc/yoshimi_user_guide/(.*/)*images/.*\.png|doc/examples/Original Zyn Patchsets/.*|doc/examples/.*\.x..|doc/examples/(Out_There|Arram_Koth_Finale)\.mid|banks/.*\.xiz|banks/Drums/0068-rimshot\.xiy|dev_notes/Yoshimi Control Numbers\.ods|doc/The Short Yoshimi Guide\.odt|doc/Histories/Yoshimi CCs and NRPNs\.pdf

# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

## yoshimi 2.3.5.2

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -55,7 +55,7 @@
 
 project (Yoshimi)
 
-set (YOSHIMI_VERSION "2.3.5.1")
+set (YOSHIMI_VERSION "2.3.5.2")
 file (WRITE version.txt "${YOSHIMI_VERSION}")

=== src/LV2_Plugin/CMakeLists.txt ===
--- 
+++ 
@@ -118,6 +118,7 @@
     ../UI/WidgetMWSlider.cpp
     ../UI/WidgetCheckButton.cpp
     ../UI/WidgetSpinner.cpp
+    ../UI/ScaleTrackedWindow.cpp
 )
 
 add_definitions (-DYOSHIMI_LV2_PLUGIN=1)

=== debian/changelog ===
yoshimi (2.3.5.2-1) unstable; urgency=medium

  * New upstream version 2.3.5.2
  * Update d/watch to version 5
  * Remove redudant rules-requires-root-no field

 -- Dennis Braun <snd@debian.org>  Sun, 09 Nov 2025 23:57:56 +0100

=== debian/control ===
--- 
+++ 
@@ -28,7 +28,6 @@
  sharutils,
  zlib1g-dev,
 Standards-Version: 4.7.2
-Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/multimedia-team/yoshimi.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/yoshimi
 Homepage: https://yoshimi.github.io

=== debian/watch ===
Version: 5
Template: Github
Owner: Yoshimi
Project: yoshimi

## yoshimi 2.3.5.3

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -55,7 +55,7 @@
 
 project (Yoshimi)
 
-set (YOSHIMI_VERSION "2.3.5.2")
+set (YOSHIMI_VERSION "2.3.5.3")
 file (WRITE version.txt "${YOSHIMI_VERSION}")
 
 
@@ -179,7 +179,7 @@
 pkg_check_modules (FFTW3F REQUIRED fftw3f>=0.22)
 
 # mxml
-pkg_check_modules (MXML REQUIRED mxml>=2.5)
+pkg_search_module (MXML REQUIRED mxml4 mxml>=2.5)
 
 # Alsa
 if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Linux")

=== debian/changelog ===
yoshimi (2.3.5.3-1) unstable; urgency=medium

  * New upstream version 2.3.5.3

  * Update copyright information
    + Update copyrights
    + Fix file-pattern for files with spaces
    + Update licensecheck exceptions
    * Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 25 Dec 2025 16:47:24 +0100

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 	dh $@ --sourcedirectory=src
 
 DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
-        debian/.*|doc/yoshimi_user_guide/(.*/)*images/.*\.png|doc/examples/Original Zyn Patchsets/.*|doc/examples/.*\.x..|doc/examples/(Out_There|Arram_Koth_Finale)\.mid|banks/.*\.xiz|banks/Drums/0068-rimshot\.xiy|dev_notes/Yoshimi Control Numbers\.ods|doc/The Short Yoshimi Guide\.odt|doc/Histories/Yoshimi CCs and NRPNs\.pdf
+        debian/.*|doc/yoshimi_user_guide/(.*/)*images/.*\.(png|jpg)|doc/examples/Original Zyn Patchsets/.*|doc/examples/.*\.x..|doc/examples/(Out_There|Arram_Koth_Finale)\.mid|banks/.*\.xiz|banks/Drums/0068-rimshot\.xiy|banks/Choir_and_Voice/0102-Vocalise\.xiy|dev_notes/Yoshimi Control Numbers\.ods|doc/The Short Yoshimi Guide\.odt|doc/Histories/Yoshimi CCs and NRPNs\.pdf
 
 # licensecheck v1
 .PHONY: licensecheck

## yoshimi 2.3.6

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -55,7 +55,7 @@
 
 project (Yoshimi)
 
-set (YOSHIMI_VERSION "2.3.5.3")
+set (YOSHIMI_VERSION "2.3.6")
 file (WRITE version.txt "${YOSHIMI_VERSION}")

=== debian/changelog ===
yoshimi (2.3.6-1) unstable; urgency=medium

  * New upstream version 2.3.6
  * Add patch to fix installation of non-existant file
  * Add explicit salsa-ci configuration
  * Drop obsolete 'Priority: optional' stanza.
  * Bump standards version to 4.7.3

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 16 Feb 2026 19:36:40 +0100

## yoshimi 2.3.6.1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -55,7 +55,7 @@
 
 project (Yoshimi)
 
-set (YOSHIMI_VERSION "2.3.6")
+set (YOSHIMI_VERSION "2.3.6.1")
 file (WRITE version.txt "${YOSHIMI_VERSION}")

=== debian/changelog ===
yoshimi (2.3.6.1-1) unstable; urgency=medium

  * New upstream version 2.3.6.1
  * Drop obsolete patches
  * Update copyright information
    + Re-generated d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 20 Feb 2026 14:16:59 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: yoshimi
 Section: sound
-Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Dennis Braun <snd@debian.org>,
@@ -27,7 +26,7 @@
  pkgconf,
  sharutils,
  zlib1g-dev,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Git: https://salsa.debian.org/multimedia-team/yoshimi.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/yoshimi
 Homepage: https://yoshimi.github.io
